subroutine v2f(V,F,ix,is,ie,jx,js,je)
  implicit none
  include 'param.h'
  integer :: ix, jx
  real(8) :: V(ix,jx,var1)  ! primitive variables (V) including B [input]
  real(8) :: F(ix,jx,var1)  ! numerical flux (F) [output]
  integer :: i, is, ie
  integer :: j, js, je
  real(8) :: v2, vB, B2, f1

  f1 = gamma / ( gamma - 1 )

  do j=js,je
  do i=is,ie

     v2 = dot_product( V(i,j,vx:vz), V(i,j,vx:vz) )
     vB = dot_product( V(i,j,vx:vz), V(i,j,bx:bz) )
     B2 = dot_product( V(i,j,bx:bz), V(i,j,bx:bz) )
     
     F(i,j,ro) = V(i,j,ro) * V(i,j,vx)
     F(i,j,mx) = V(i,j,ro)*V(i,j,vx)*V(i,j,vx) - V(i,j,bx)*V(i,j,bx) &
          + V(i,j,pr) + 0.5d0*B2
     F(i,j,my) = V(i,j,ro)*V(i,j,vx)*V(i,j,vy) - V(i,j,bx)*V(i,j,by)
     F(i,j,mz) = V(i,j,ro)*V(i,j,vx)*V(i,j,vz) - V(i,j,bx)*V(i,j,bz)
     F(i,j,en) = ( 0.5d0*V(i,j,ro)*v2 + f1*V(i,j,pr) + B2 ) * V(i,j,vx) - vB * V(i,j,bx)
     F(i,j,bx) = V(i,j,ps)
     F(i,j,by) = V(i,j,vx)*V(i,j,by)-V(i,j,bx)*V(i,j,vy)
     F(i,j,bz) = V(i,j,vx)*V(i,j,bz)-V(i,j,bx)*V(i,j,vz)
     F(i,j,ps) = 0.d0
!     F(i,j,ps) = V(i,j,bx)
     
  enddo
  enddo

  return
end subroutine v2f
